#!/bin/sh

# add bin to path
export PATH=../bin:$PATH

#TARGET=debug
TARGET=release

PROGRAM=../bin/$TARGET/Preprocessor.exe

echo "starting $TARGET mode"

#SCENE=vsposp_typical
SCENE=soda5_vsposp
#SCENE=soda_vsposp
#SCENE=vienna_vsposp
#SCENE=arena_vsposp
#SCENE=vsposp_citymodel
#SCENE=soda5
#SCENE=cube
#SCENE=atlanta
#SCENE=vienna

LOG_PREFIX=../scripts/tests/i3d/$SCENE

ENVIRONMENT=$SCENE.env

#######################################################


 METHOD=interleaved_full
 echo "$SCENE $METHOD"

# $PROGRAM $ENVIRONMENT \
# -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
# -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
# -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
# -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
# -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
# -hierarchy_construction_type=1 \
# -hierarchy_construction_recompute_split_on_repair=true

sh movefiles.sh $LOG_PREFIX-$METHOD

###########################################################################

 METHOD=interleaved
 echo "$SCENE $METHOD"

# $PROGRAM $ENVIRONMENT \
# -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
# -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
# -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
# -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
# -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
# -hierarchy_construction_type=1 \
# -hierarchy_construction_recompute_split_on_repair=false

sh movefiles.sh $LOG_PREFIX-$METHOD

##################################################################################

 METHOD=gradient-mem
 echo "$SCENE $METHOD"

  $PROGRAM $ENVIRONMENT \
  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
  -hierarchy_construction_type=2 \
  -hierarchy_construction_consider_memory=false \
  -hierarchy_construction_multilevel=false \
  -hierarchy_term_memory_const=0.9 \
  -hierarchy_construction_recompute_split_on_repair=true

sh movefiles.sh $LOG_PREFIX-$METHOD


############################################################################
NODES=1000

  METHOD=sequential-$NODES
  echo "$SCENE $METHOD"

# $PROGRAM $ENVIRONMENT \
  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
  -hierarchy_construction_type=0 \
  -bvh_term_max_leaves=$NODES

sh movefiles.sh $LOG_PREFIX-$METHOD

############################################################################

NODES=10000

  METHOD=sequential-$NODES
  echo "$SCENE $METHOD"

 #$PROGRAM $ENVIRONMENT \
  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
  -hierarchy_construction_type=0 \
  -bvh_term_max_leaves=$NODES

sh movefiles.sh $LOG_PREFIX-$METHOD


############################################################################

NODES=30000

  METHOD=sequential-$NODES
  echo "$SCENE $METHOD"

#  $PROGRAM $ENVIRONMENT \
#   -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
#   -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
#   -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
#   -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
#   -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
#   -hierarchy_construction_type=0 \
#   -bvh_term_max_leaves=$NODES

sh movefiles.sh $LOG_PREFIX-$METHOD


###############################################################
MEMCONST=1.0
 METHOD=gradient-$MEMCONST
 echo ********" $SCENE $METHOD ************"

# $PROGRAM $ENVIRONMENT \
 -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
 -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
 -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
 -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
 -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
 -hierarchy_construction_type=2 \
 -hierarchy_construction_multilevel=false \
 -hierarchy_construction_levels=4 \
 -hierarchy_construction_consider_memory=true \
 -hierarchy_term_memory_const=$MEMCONST \
 -bvh_construction_render_cost_decrease_weight=0.99 \
 -vsp_construction_render_cost_decrease_weight=0.99 \
 -hierarchy_construction_recompute_split_on_repair=true

sh movefiles.sh $LOG_PREFIX-$METHOD

#########################################################################

MEMCONST=0.1
 METHOD=gradient-$MEMCONST
 echo ********" $SCENE $METHOD ************"

 #$PROGRAM $ENVIRONMENT \
 -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
 -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
 -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
 -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
 -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
 -hierarchy_construction_type=2 \
 -hierarchy_construction_multilevel=false \
 -hierarchy_construction_levels=4 \
 -hierarchy_construction_consider_memory=true \
 -hierarchy_term_memory_const=$MEMCONST \
 -bvh_construction_render_cost_decrease_weight=0.99 \
 -vsp_construction_render_cost_decrease_weight=0.99 \
 -hierarchy_construction_recompute_split_on_repair=true

sh movefiles.sh $LOG_PREFIX-$METHOD


########################################################################

METHOD=gradient_simplesplit
echo "$SCENE $METHOD"

#$PROGRAM $ENVIRONMENT \
 -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
 -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
  -bvh_use_sah=true \
  -vsp_use_cost_heuristics=true \
  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
  -hierarchy_construction_type=2 \
  -hierarchy_construction_recompute_split_on_repair=true

sh movefiles.sh $LOG_PREFIX-$METHOD

##########################################################
 METHOD=gradient-500
 echo "$SCENE $METHOD"

#  $PROGRAM $ENVIRONMENT \
  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
  -hierarchy_construction_type=2 \
  -hierarchy_construction_consider_memory=false \
  -hierarchy_construction_min_steps_same_type=500 \
  -hierarchy_construction_multilevel=false \
  -hierarchy_construction_recompute_split_on_repair=true

sh movefiles.sh $LOG_PREFIX-$METHOD


############################################################################

